{     ;   
  ,       }
{$PackRecords 1}
{$ifdef UNIX}
  {$define mcrt}
{$endif}
Uses dos {$ifdef UNIX}, encoding{$endif}
, {$ifdef mcrt}mcrt{$else}crt{$endif};

Type
  RngDet	= 0..9999;

  Tname		= String[20];			// 
  Tchar		= String[10];			// 
  Tmark		= String[15];			// /
  Tcnt		= Word;				// 
  Trem		= String[44];			// 
  Tdate		= LongInt;			//  
  Tattr		= Word;				// ,  ...
  Ttara		= String[10];			// / 

  Tdet		= Record
    name	: Tname;
    value	: Tchar;
    mark	: Tmark;
    cnt		: Tcnt;
    rem		: Trem;
    date	: Tdate;
    attr	: Tattr;
    tara	: Ttara;
  End;
  Pdet		= ^Tdet;

Const
  NumDet	: RngDet	= Low(RngDet);
  Column	: Byte		= 1;
  TopY		: RngDet	= Low(RngDet);
  TopX		: Byte		= 0;
  Curs		: RngDet	= Low(RngDet);
  PropCol	: Boolean	= True;
  OutY1		= 2;
  BaseName	= 'astalast.dat';

Var
  Base		: Array[RngDet] of Pdet;
  SrchStr,
  ClipBoard	: String;
  KeyInResult	: Word;
  KeyInRes	: Array[0..1] of Byte Absolute KeyInResult;
  OutY2		: Byte;
  CntDet	: RngDet;


//    
Function LowStr(const s: String): String;
Var n: Byte; b: Array[0..255] of Byte absolute LowStr;
Begin
  LowStr:=s;
  For n:=1 to Length(LowStr) do Case LowStr[n] of
{$ifdef UNIX}
    'A'..'Z': inc(b[n], 32);
    ''..'': dec(b[n], 32);
    ''     : b[n]:=ord('');
{$endif}
{$ifdef GO32V2}
    'A'..'Z', ''..'': inc(b[n], 32);
    ''..''          : inc(b[n], 80);
{$endif}
  End;
End;


//      
Function CmpStr(const s1, s2: String): Boolean;
begin
{$ifdef UNIX}
  CmpStr:=k2a_encode(s1) < k2a_encode(s2);
{$endif}
{$ifdef GO32V2}
  CmpStr:=s1 < s2;
{$endif}
end;


//        
Function scmp(s1, s2: String): Boolean;
Const modif: Array[0..9] of Record
  Suffix	: String[4];
  St		: Byte;
  Multer	: Single;
End=(
  (Suffix:  ''; St: 0; Multer: 1e+00),
  (Suffix: ''; St: 0; Multer: 1e+03),
  (Suffix:   ''; St: 0; Multer: 1e+03),
  (Suffix: ''; St: 0; Multer: 1e+06),
  (Suffix:   ''; St: 0; Multer: 1e+06),
  (Suffix:  ''; St: 1; Multer: 1e-12),
  (Suffix:  ''; St: 1; Multer: 1e-09),
  (Suffix: ''; St: 1; Multer: 1e-06),
  (Suffix:   ''; St: 2; Multer: 1e+00),
  (Suffix:   ''; St: 2; Multer: 1e+00)
);

  // ,  ,    ,     
  Function c(s: String; Var s1: Byte; Var r: Single): Boolean;
  Var ld, ls, j, n: Byte; i: Integer;
  Begin
    c:=False;
    For n:=Low(modif) to High(modif) do With modif[n] do Begin
      ld:=Length(s); ls:=Length(Suffix);
      For j:=1 to ld do If s[j]=',' then s[j]:='.';
      If ld>ls then If copy(s,ld-ls+1,ls)=Suffix then Begin
	val(copy(s,1,ld-ls),r,i);
	If i=0 then Begin
	  r:=r*Multer; s1:=St; c:=True; Exit;
	End;
      End;
    End;
  End;

Var St1, St2: Byte; M1, M2: Single; c1, c2: Boolean;
Begin
  s1:=LowStr(s1); s2:=LowStr(s2);
  c1:=c(s1, St1, M1); c2:=c(s2, St2, M2);
  If c1 and c2 then Begin
    If St1=St2 then scmp:=M1 < M2 else scmp:=St1 < St2;
    Exit;
  End;
  If not c1 and not c2 then Begin
    scmp:=CmpStr(s1, s2);
    Exit;
  End;
  scmp:=c1 and not c2;
End;

Type tcmp = Function(a1, a2: TDet): Boolean;

Function cmp_nm_vl_mk(a1, a2: TDet): Boolean;
Begin
  If a1.name = a2.name then
    If a1.value = a2.value then
      cmp_nm_vl_mk:=CmpStr(a1.mark, a2.mark)
    else
      cmp_nm_vl_mk:=scmp(a1.value, a2.value)
  else
    cmp_nm_vl_mk:=CmpStr(a1.name, a2.name);
End;

Function cmp_nm_mk_vl(a1, a2: TDet): Boolean;
Begin
  If a1.name = a2.name then
    If a1.mark = a2.mark then
      cmp_nm_mk_vl:=scmp(a1.value, a2.value)
    else
      cmp_nm_mk_vl:=CmpStr(a1.mark, a2.mark)
  else
    cmp_nm_mk_vl:=CmpStr(a1.name, a2.name);
End;

Function cmp_nm_vl_rm(a1, a2: TDet): Boolean;
Begin
  If a1.name = a2.name then
    If a1.value = a2.value then
      cmp_nm_vl_rm:=CmpStr(a1.rem, a2.rem)
    else
      cmp_nm_vl_rm:=scmp(a1.value, a2.value)
  else
    cmp_nm_vl_rm:=CmpStr(a1.name, a2.name);
End;

Function cmp_tr_nm_mk_vl(a1, a2: TDet): Boolean;
Begin
  If a1.tara = a2.tara then
    If a1.name = a2.name then
      If a1.mark = a2.mark then
	cmp_tr_nm_mk_vl:=scmp(a1.value, a2.value)
      else
	cmp_tr_nm_mk_vl:=CmpStr(a1.mark, a2.mark)
    else
      cmp_tr_nm_mk_vl:=CmpStr(a1.name, a2.name)
  else
    cmp_tr_nm_mk_vl:=CmpStr(a1.tara, a2.tara);
End;

Function cmp_name(a1, a2: TDet): Boolean;
Begin cmp_name:=CmpStr(a1.name, a2.name) End;

Function cmp_mark(a1, a2: TDet): Boolean;
Begin cmp_mark:=CmpStr(a1.mark, a2.mark) End;

Function cmp_value(a1, a2: TDet): Boolean;
Begin cmp_value:=scmp(a1.value, a2.value) End;

Function cmp_rem(a1, a2: TDet): Boolean;
Begin cmp_rem:=CmpStr(a1.rem, a2.rem) End;

Function cmp_tara(a1, a2: TDet): Boolean;
Begin cmp_tara:=CmpStr(a1.tara, a2.tara) End;


//     cmp
Procedure Sort(Const cmp: tcmp);

  Procedure InSort(l, r: Integer);
  Var i, j: Integer; x, y: pDet;
  Begin
    i := l; j := r; x := Base[(l+r) DIV 2];
    If x=Nil then RunError(0);
    Repeat
      while cmp(Base[i]^, x^) do i := i + 1;
      while cmp(x^, Base[j]^) do j := j - 1;
      If i <= j then
      Begin
	y := Base[i]; Base[i] := Base[j]; Base[j] := y;
	If y=Nil then RunError(0);
	i := i + 1; j := j - 1;
      End;
    Until i > j;
    If l < j then InSort(l, j);
    If i < r then InSort(i, r);
  End;

Begin
  InSort(0, NumDet-1);
End;


//  
Procedure KeyIn;
begin
  KeyInRes[0]:=Ord(ReadKey);
  if KeyInRes[0] = 0 then KeyInRes[1]:=Ord(ReadKey) else KeyInRes[1]:=0;
end;


//  
Function EnterS(Var gBuf: String; Const Prompt: PChar; Const MaxLen: Byte): Boolean;
Const Curs: Byte=0;
Var HTab: Byte; Modif: Boolean; tBuf: String; tmp: PChar;

Begin
  TextAttr:=15;
{$ifdef mcrt}
  printw(#13'%s: ', [Prompt]);
{$else}
  Write(#13, Prompt, ': ');
{$endif}
  HTab := WhereX; Modif:=False; tBuf:=gBuf;
  If Length(tBuf) < Curs then Curs:=Length(tBuf);
  Repeat
    GotoXY(HTab, WhereY);
    If Modif then TextAttr:=$07 else TextAttr:=$70;
{$ifdef mcrt}
    tmp:=@(tBuf[1]); tmp[Length(tBuf)]:=#0; printw('%s', [tmp]);
{$else}
    Write(tBuf);
{$endif}
    ClrEol;
    GotoXY(HTab+Curs, WhereY);
    Repeat KeyIn Until KeyInResult<>0;
    Case KeyInResult of
       22: tBuf:=ClipBoard;     { ^V }
       24: ClipBoard:=tBuf;     { ^X }
    19200: If Curs > 0 then dec(Curs);
    19712: If Curs < Length(tBuf) then inc(Curs);
    18176: Curs:=0;
    20224: Curs:=Length(tBuf);
        8: If Curs <> 0 then Begin Delete(tBuf, Curs, 1); dec(Curs) End;
    21248: If Curs < Length(tBuf) then Delete(tBuf, Curs+1, 1);
    else
      If (Curs < MaxLen) and (KeyInRes[0] > 31) then
        If Modif then Begin
  	  If Length(tBuf) < MaxLen then Begin
	    inc(Curs); Insert(Chr(KeyInRes[0]), tBuf, Curs);
	  End
        End else Begin
          Curs:=1; tBuf:=Chr(KeyInRes[0]);
        End;
    End;
    Modif:=True;
  Until (KeyInRes[0]=13) or (KeyInRes[0]=27);

  EnterS:=False;

  If KeyInRes[0]=13 then Begin
    While (Length(tBuf) > 0) and (tBuf[Length(tBuf)]=' ') do Delete(tBuf, Length(tBuf), 1);
    gBuf:=tBuf; EnterS:=True;
  End;

  KeyInResult:=0;
End;


//     
Procedure OutBase;
Const
  InvChar	= '\';
  NorChar	= '@';
  DivString	= ' | ';

Var
  VTab, CntChar,
  CntPos	: Byte;
  CntDet	: RngDet;
  OutStr	: String;
  dt		: DateTime;
  c1		: String[5];
  c2		: String[3];
  c3		: String[11];
  lcol		: Array[1..6] of Byte;	//  

  //   ()  
  Procedure SearchMax;
  Var x: Byte; Cnt, f, t: RngDet;

  Begin
    For x:=1 to 6 do lcol[x]:=0; lcol[4]:=3;
    If PropCol then Begin
      f:=TopY; t:=TopY+(OutY2-OutY1);
    End else Begin
      f:=Low(RngDet); t:=Pred(NumDet);
    End;
    For Cnt:=f to t do If Cnt < NumDet then With Base[Cnt]^ do Begin
      If lcol[1]<Length(name ) then lcol[1]:=Length(name );
      If lcol[2]<Length(value) then lcol[2]:=Length(value);
      If lcol[3]<Length(mark ) then lcol[3]:=Length(mark );
      If lcol[5]<Length(rem  ) then lcol[5]:=Length(rem  );
      If lcol[6]<Length(tara ) then lcol[6]:=Length(tara );
    End;
  End;

  //      
  Procedure AddCol(Const c: Byte; s: String);
  Begin
    If c in [1..6] then While Length(s) < lcol[c] do s:=s+' ';
    If Column = c then OutStr:=OutStr + InvChar;
    OutStr:=OutStr + s + NorChar + DivString;
  End;

  //     
  Function Ext(Const d: Byte): String[2];
  Begin Str(d: 2, Ext); If Ext[1]=' ' then Ext[1]:='0'; End;

Begin
  SearchMax; CntDet:=TopY;
  For VTab:=OutY1 to OutY2-1 do Begin
    GotoXY(1, VTab); TextAttr:=8;
//  If (VTab-(OutY1+1))/((OutY2-2)-(OutY1+1))<(TopY+OutY2-OutY1-1)/NumDet then write(#$b2) else write(#$b0);
    If CntDet < NumDet then Begin

      With Base[CntDet]^ do Begin
        str(CntDet : 4, c1);
	if cnt > 999 then cnt:=999; // FPC RTL bug workaround 
        str(cnt    : 3, c2);
	UnPackTime(date, dt);
	With dt do c3:=Ext(Hour) + '-' + Ext(Day) + '.' + Ext(Month) + '.' + Ext(Year mod 100);

	OutStr:=NorChar;

	AddCol(0, c1);
	AddCol(1, name);
	AddCol(2, value);
	AddCol(3, mark);
	AddCol(4, c2);
	AddCol(5, rem);
	AddCol(6, tara);
	AddCol(7, c3);
      End;

      CntChar:=1; CntPos:=0; //textattr:=1; addch('*');
      While (CntChar <= Length(OutStr)) and (WhereX < WindMax and 255) do Begin
	If Base[CntDet]^.Attr and $0001 <> 0 then TextAttr:=Byte(TextAttr) or $08;
	Case OutStr[CntChar] of
	  NorChar: If CntDet = Curs then TextAttr:=$70 else TextAttr:=$07;
	  InvChar: If CntDet = Curs then TextAttr:=$60 else TextAttr:=$06;
	else
	  Begin
	    If CntPos >= TopX then If OutStr[CntChar] >= ' ' then 
	    {$ifdef mcrt}
	      addch(ord(OutStr[CntChar])) else addch(ord('?'));
	    {$else}
	      Write(OutStr[CntChar]) else Write('?');
	    {$endif}
	    inc(CntPos);
	  End;
	End;
	inc(CntChar);
      End;

      inc(CntDet);
    End;
    ClrEol;
  End;
End;


//   
Procedure OutParam;
var p: PChar;
Begin
  Case Column of
    1: p:='';
    2: p:='';
    3: p:='';
    4: p:='';
    5: p:='';
    6: p:='';
  End;
  GotoXY(1, 1); TextAttr:=15;
{$ifdef mcrt}
  printw('%d / %d     %s', [Curs, NumDet - Low(RngDet), p]);
{$else}
  Write(Curs, ' / ', NumDet - Low(RngDet), '    ');
{$endif}
//  TextAttr:=8; Write('   Mem: ', MemSize(@Curs)); // ????
  ClrEol;
End;


//     s1   s2   
Function InStr(Const s1, s2: String): Boolean;
Begin InStr:=pos(LowStr(s1), LowStr(s2)) <> 0 End;


//    
Procedure GeneralSearch(Const mode: Boolean);
Var b: Byte;
Begin
  If mode then
    Case Column of
    1: b:=$01;
    2: b:=$02;
    3: b:=$04;
    5: b:=$10;
    6: b:=$20;
    End
  else
    b:=$FF;
  If SrchStr<>'' then Begin
    For CntDet:=Succ(Curs) to Pred(NumDet) do With Base[CntDet]^ do Begin
      If InStr(SrchStr, name) and (b and $01 <> 0) then Begin Column:=1; break End;
      If InStr(SrchStr,value) and (b and $02 <> 0) then Begin Column:=2; break End;
      If InStr(SrchStr, mark) and (b and $04 <> 0) then Begin Column:=3; break End;
      If InStr(SrchStr,  rem) and (b and $10 <> 0) then Begin Column:=5; break End;
      If InStr(SrchStr, tara) and (b and $20 <> 0) then Begin Column:=6; break End;
    End;
    Curs:=CntDet; TopY:=Succ(CntDet); //???
  End;
End;

{
Procedure Join;
label Ok, Dif;
Const FN: String='astalast.dat';
Var c: file of Tdet;
    d: Tdet;
p1,p2: ^Byte;
    n: Word;

Begin
  If EnterS(FN,'    ',SizeOf(FN)-1) then Begin
    For CntDet:=0 to NumDet-1 do With Base[CntDet]^ do Attr:=Attr and $FFFE;
    assign(c,FN); reset(c);
    while not eof(c) do Begin
      read(c,d);
      For CntDet:=0 to NumDet-1 do Begin
	Pointer(p1):=Pointer(Base[CntDet]); Pointer(p2):=Pointer(@d);
	For n:=1 to SizeOf(d) do Begin
	  If p1^<>p2^ then goto Dif;
	  inc(p1); inc(p2);
	End;
	goto Ok;
	Dif:
      End;

      If NumDet<High(RngDet) then Begin
	New(Base[NumDet]);
	d.Attr:=d.Attr or $0001;
	Base[NumDet]^:=d;
	Curs:=NumDet;
	inc(NumDet);
      End else Begin
	gotoXY(1,1); TextAttr:=$C0;
	write('     .');
	close(c); readln; exit;
      End;

      Ok:
    End;
    close(c);
  End;
End;
}


//     /
Procedure SetDate(Var d: Tdate);
Var DT : DateTime; WDay, Sec100: Word;
Begin
  With DT do Begin
    GetDate(Year, Month, Day, WDay);
    GetTime(Hour, Min, Sec, Sec100);
  End;
  PackTime(DT, d);
End;


{
Procedure TextOut;
Var f:text;
Begin
  assign(f,'astalast.txt'); rewrite(f);
  For CntDet:=0 to NumDet-1 do With Base[CntDet]^ do
    If value='*' then writeln(f,mark,#9#9,rem);
  close(f);
End;
}


//    
Procedure ReadBase;
var b: File of Tdet; //h, d, m, y: Cardinal;
Begin
  Assign(b, BaseName); Reset(b);
  While Not Eof(b) do Begin
    New(Base[NumDet]); Read(b, Base[NumDet]^);
    With Base[NumDet]^ do Begin
{$ifdef UNIX}
      name := a2k_encode(name );
      value:= a2k_encode(value);
      mark := a2k_encode(mark );
      rem  := a2k_encode(rem  );
      tara := a2k_encode(tara );
{$endif}
{
//	hy+0 = year-1980, hy+1 = hour,  md+0 = day    md+1 = month  
       y:=(date and 255);
       h:=(date shr 8)  and 255;
       d:=(date shr 16) and 255;
       m:=(date shr 24) and 255;
       date:=(y shl 25) or (m shl 21) or (d shl 16) or (h shl 11);
//	Table 01665 of Ralf Brown
}
    End;
    inc(NumDet);
  End;
  Close(b);
//If NumDet=low(RngDet) then inc(NumDet);
End;


//    
Procedure WriteBase;
var b: File of Tdet; t: Tdet; CntDet: RngDet;
Begin
  GotoXY(1, 1); TextAttr:=$70;
{$ifdef mcrt}
  printw('...', []);
{$else}
  Write('...');
{$endif}
  Assign(b, BaseName); ReWrite(b);
  For CntDet:=Low(RngDet) to Pred(NumDet) do With Base[CntDet]^ do Begin
{$ifdef UNIX}
    t.name :=k2a_encode(name );
    t.value:=k2a_encode(value);
    t.mark :=k2a_encode(mark );
    t.cnt  :=cnt;
    t.rem  :=k2a_encode(rem  );
    t.date :=date;
    t.attr :=attr;
    t.tara :=k2a_encode(tara );
    Write(b, t);
{$endif}
{$ifdef GO32V2}
    Write(b, Base[CntDet]^);
{$endif}
  End;
  Close(b);
End;


//     
Procedure EnterCell;
var s2v: String[4]; i: Integer;
begin
  With Base[Curs]^ do Case Column of
     1: If EnterS( name,' ',SizeOf(name)-1) then SetDate(date);
     2: If EnterS(value,'',SizeOf(value)-1) then SetDate(date);
     3: If EnterS( mark,'/',SizeOf(mark)-1) then SetDate(date);
     4: Begin
	  str(cnt, s2v);
	  If EnterS(s2v,' ',SizeOf(s2v)-1) then Begin
	    val(s2v, cnt, i);
	    SetDate(date);
	  End;
	End;
     5: If EnterS(  rem,'',SizeOf(rem)-1) then SetDate(date);
     6: If EnterS( tara,'',SizeOf(tara)-1) then SetDate(date);
  End;
End;


// " ?"
Function SureExit: Boolean;
var i: Char;
begin
  SureExit:=False;
  If KeyInRes[0]=ord('q') then Begin
    ClrScr;
{$ifdef mcrt}
    printw('   ? (y/n) ', []);
{$else}
    Write('   ? (y/n) ');
{$endif}
    Repeat i:=ReadKey Until i in ['y', 'Y', 'n', 'N'];
    SureExit := i in ['y', 'Y'];
  End;
end;


Begin
  ClrScr; ClipBoard:=''; ReadBase;

  Repeat
    OutY2:=(WindMax shr 8){+2};
    OutBase; OutParam;

    Repeat KeyIn Until KeyInResult<>0;

    Case KeyInResult of
	   // Home
    18176: Begin Curs:=low(RngDet); TopY:=Curs End;
	   // a
       97: Case Column of
	   2: Sort(@cmp_nm_vl_mk);
	   3: Sort(@cmp_nm_mk_vl);
	   5: Sort(@cmp_nm_vl_rm);
	   6: Sort(@cmp_tr_nm_mk_vl);
	   End;
	   // Tab
        9: Case Column of
	   1: Sort(@cmp_name);
	   2: Sort(@cmp_value);
	   3: Sort(@cmp_mark);
	   5: Sort(@cmp_rem);
	   6: Sort(@cmp_tara);
	   End;
      116: // t
	   With Base[Curs]^ do Attr:=Attr xor 1;
	   // -
       45: For CntDet:=0 to NumDet-1 do With Base[CntDet]^ do Attr:=Attr and $FFFE;
	   // *
       42: For CntDet:=0 to NumDet-1 do With Base[CntDet]^ do Attr:=Attr xor $0001;
	   // F8
    16896: If Curs < Pred(NumDet) then
	     For CntDet:=Curs+1 to NumDet-1 do
	       If Base[CntDet]^.Attr and $0001 <> 0 then Begin
		 Curs:=CntDet;
		 break;
	       End;
	   // F9
    17152: If NumDet < High(RngDet) then Begin
	     New(Base[NumDet]);
	     FillChar(Base[NumDet]^, SizeOf(tDet), 0);
	     Curs:=NumDet;
	     inc(NumDet);
	   End;
	   // del
    21248: If NumDet > Succ(Low(RngDet)) then Begin
	     For CntDet:=Curs+1 to NumDet-1 do Base[CntDet-1]^:=Base[CntDet]^;
	     dec(NumDet); Dispose(Base[NumDet]);
	   End;
	   // ins
    20992: If NumDet < High(RngDet) then Begin
	     inc(Curs); New(Base[NumDet]);
	     For CntDet:=NumDet downto Curs do Base[CntDet]^:=Base[CntDet-1]^;
	     inc(NumDet);
	     With Base[Curs]^ do Begin Attr:=Attr or $0001; SetDate(date); End;
	   End;
	   // 
    18432: if Curs>Low(RngDet) then dec(Curs);
	   // 
    20480: if Curs<Pred(NumDet) then inc(Curs);
	   // PgUp
    18688: If Curs-(OutY2-OutY1) < Low(RngDet) then Curs:=Low(RngDet) else dec(Curs, OutY2-OutY1);
           // PgDn
    20736: If Curs+(OutY2-OutY1) > Pred(NumDet) then Curs:=Pred(NumDet) else inc(Curs, OutY2-OutY1);
           // ->
    19712: If TopX < 247 then inc(TopX, 8) else TopX:=255;
           // <-
    19200: If TopX > 7 then dec(TopX, 8) else TopX:=0;
           // z
      122: If Column>1 then dec(Column);
           // c
       99: If Column<6 then inc(Column);
           // F12
    34304: WriteBase;
           // S
       83: GeneralSearch(False);
           // ^s
       19: GeneralSearch(True);
	   // s
      115: If EnterS(SrchStr,'  ',SizeOf(SrchStr)-1) then GeneralSearch(False);
           // Enter
       13: EnterCell;
	   // Space
       32: PropCol:=not PropCol;
    End;
    If Curs >= NumDet then Curs:=Pred(NumDet);
    If TopY > Curs then TopY:=Curs;
    If TopY+(OutY2-OutY1-1) < Curs then TopY:=Curs - (OutY2-OutY1-1);
  Until SureExit;
End.