#include <curses.h>
#include <stdio.h>

void m_init_pair() {
  int i, j, c=1,
    c_ind[8]={COLOR_BLACK, COLOR_RED, COLOR_GREEN, COLOR_YELLOW,
	      COLOR_BLUE, COLOR_MAGENTA, COLOR_CYAN, COLOR_WHITE};

  for (i = 0; i <= 7; i++) {
    for (j = 0; j <= 7; j++) {
      if (i != 0 || j != 0) {
        if (c > COLOR_PAIRS-1) { puts("mcrt: COLOR_PAIRS fault\n"); exit(12); }
        init_pair(i*8 + j, c_ind[j], c_ind[i]);
        c++;
      }
    };
  };
}

void m_setattr(char c) {
  short t;
  t = ((c >> 1) & 0x38) | (c & 0x07);
  if (c & 0x08) { attron(A_BOLD); } else { attroff(A_BOLD); };
  attron(COLOR_PAIR(t));
//  printw("==%d %d %d", sizeof(chtype), TRUE, FALSE);
}

void m_getyx(WINDOW *win, int *y, int *x) {
  getyx(win, *y, *x);
}

void m_getparyx(WINDOW *win, int *y, int *x) {
  getparyx(win, *y, *x);
}

void m_getbegyx(WINDOW *win, int *y, int *x) {
  getbegyx(win, *y, *x);
}

void m_getmaxyx(WINDOW *win, int *y, int *x) {
  getmaxyx(win, *y, *x);
}
		      